---
title: Creating Textures
layout: default
root: ../../
---

## Introduction

In this chapter we will learn how to create and optimise textures for
Minetest. We will use techniques relevant for pixel art.

* Resources
* Editors
* Common Mistakes

## Resources

* [16×16 Pixel Art Tutorial](http://www.photonstorm.com/art/tutorials-art/16x16-pixel-art-tutorial)

## About MS Paint

You need to be aware that MS Paint does not support transparency.
This won't matter if you're making textures for the side of nodes,
but generally you need transparency for craft items, etc.

## Editing in GIMP

GIMP is commonly used in the Minetest community. It has quite a high
learning curve as lots of its features are hidden away.

### Use the pencil tool to edit individual pixels

<figure>
    <img src="{{ page.root }}/static/pixel_art_gimp_pencil.png" alt="Pencil in GIMP">
    <figcaption>
        Pencil in GIMP
    </figcaption>
</figure>

### Set the rubber to hard edge

<figure>
    <img src="{{ page.root }}/static/pixel_art_gimp_rubber.png" alt="Rubber in GIMP">
    <figcaption>
        Rubber in GIMP
    </figcaption>
</figure>

## Common Mistakes

### Blurred textures through usage of incorrect tools

For the most part, you want to manipulate pixels on an individual basis.
The tool for this in most editors is the pencil tool.
